Main Page | Modules | Class Hierarchy | Alphabetical List | Class List | File List | Class Members | Related Pages

# SoPerspectiveCamera Class Reference
[Nodes]

`#include <Inventor/nodes/SoPerspectiveCamera.h>`

Inheritance diagram for SoPerspectiveCamera:

List of all members.

## Detailed Description

The SoPerspectiveCamera class defines a camera node with perspective rendering.

For realistic looking 3D scene, the geometry should be rendered with perspective calculations. Use this camera type to accomplish this.

## Public Member Functions
| SoPerspectiveCamera (void)
virtual void | scaleHeight (float scalefactor)
virtual SbViewVolume | getViewVolume (float useaspectratio=0.0f) const
## Static Public Member Functions
void | initClass (void)
## Public Attributes
SoSFFloat | heightAngle
## Protected Member Functions
virtual | ~SoPerspectiveCamera ()
virtual void | viewBoundingBox (const SbBox3f &box, float aspect, float slack)

## Constructor & Destructor Documentation

SoPerspectiveCamera::SoPerspectiveCamera | ( | void |  | ) |

| Constructor.

SoPerspectiveCamera::~SoPerspectiveCamera | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoPerspectiveCamera::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoCamera.

void SoPerspectiveCamera::scaleHeight | ( | float | scalefactor | ) | `[virtual]`

| Scale the SoPerspectiveCamera::heightAngle field by multiplying with scalefactor. Implements SoCamera.

SbViewVolume SoPerspectiveCamera::getViewVolume | ( | float | useaspectratio = 0.0f | ) | const`[virtual]`

| Returns total view volume covered by the camera under the current settings. This view volume is not adjusted to account for viewport mapping. If you want the same view volume as the one used during rendering, you should do something like this:
      SbViewVolume vv;
      float aspectratio = myviewport.getViewportAspectRatio();

      switch (camera->viewportMapping.getValue()) {
      case SoCamera::CROP_VIEWPORT_FILL_FRAME:
      case SoCamera::CROP_VIEWPORT_LINE_FRAME:
      case SoCamera::CROP_VIEWPORT_NO_FRAME:
        vv = camera->getViewVolume(0.0f);
        break;
      case SoCamera::ADJUST_CAMERA:
        vv = camera->getViewVolume(aspectratio);
        if (aspectratio < 1.0f) vv.scale(1.0f / aspectratio);
        break;
      case SoCamera::LEAVE_ALONE:
        vv = camera->getViewVolume(0.0f);
        break;
      default:
        assert(0 && "unknown viewport mapping");
        break;
      }
Also, for the CROPPED viewport mappings, the viewport might be changed if the viewport aspect ratio is not equal to the camera aspect ratio. See SoCamera::getView() to see how this is done. Implements SoCamera.

void SoPerspectiveCamera::viewBoundingBox | ( | const SbBox3f & | box,
|  | float | aspect,
|  | float | slack
| ) | `[protected, virtual]`

| Convenience method for setting up the camera definition to cover the given bounding box with the given aspect ratio. Multiplies the exact dimensions with a slack factor to have some space between the rendered model and the borders of the rendering area. If you define your own camera node class, be aware that this method should not set the orientation field of the camera, only the position, focal distance and near and far clipping planes. Implements SoCamera.

## Member Data Documentation

SoSFFloat SoPerspectiveCamera::heightAngle

| The vertical angle of the viewport, also known as "field of view". Default value is 45° (note: value is specified in radians).

The documentation for this class was generated from the following files:

- SoPerspectiveCamera.h
- SoPerspectiveCamera.cpp